<template>
  <form class="form">
    <h1 class="form__header">Membership</h1>
    <div class="form__checkbox form-checkbox">
      <div class="form-checkbox__field" @click="membership = Membership[Membership.Regular]">
        <input type="radio" name="membership" class="form-checkbox__input"
               :checked="membership === Membership[Membership.Regular]">
        <span class="form-checkbox__checkmark"></span>
      </div>
      <label class="form-checkbox__label">Regular</label>
    </div>
    <div class="form__checkbox form-checkbox">
      <div class="form-checkbox__field" @click="membership = Membership[Membership.Premium]">
        <input type="radio" name="membership" class="form-checkbox__input"
               :checked="membership === Membership[Membership.Premium]">
        <span class="form-checkbox__checkmark"></span>
      </div>
      <label class="form-checkbox__label">Premium</label>
    </div>
    <p class="form__membership-text" v-if="membership === Membership[Membership.Premium]">Lorem ipsum dolor sit amet,
      consectetur adipiscing
      elit. Pellentesque urna, ligula eget maecenas. At pharetra fermentum.</p>
    <p class="form__membership-text" v-else>Sed morbi sed est, ultrices in vel maecenas. Lorem ipsum dolor sit amet,
      consectetur adipiscing elit. Pellentesque urna, ligula eget maecenas.</p>
    <button
        type="submit"
        @click.prevent="next"
        class="button _nav">Continue
    </button>
    <button
        type="submit"
        @click.prevent="back"
        class="button _nav _white">Back
    </button>
  </form>
</template>

<script lang="ts">
import {Ref, computed, defineComponent, ref} from 'vue';
import {useStore} from 'vuex';
import {useRouter} from 'vue-router'
import {Membership, Steps} from '@/models/types'

export default defineComponent({
  setup() {

    const {push} = useRouter()
    const store = useStore()

    const storeMembership = computed(() => store.getters.membership)
    const membership: Ref<string> = ref(storeMembership.value)

    function next(): void {
      store.dispatch('saveMembership', membership.value)
      push({name: 'overview'})
    }

    function back(): void {
      push({name: 'contact-info'})
      store.dispatch('stepBack', Steps[Steps.ContactInfo])
    }

    return {membership, next, back, Membership}
  }
});
</script>
